unit DesignUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnCtrls, ActnMan, ActnMenus, XPStyleActnCtrls, ActnList,
  ToolWin, ComCtrls, ImgList, JvExControls, JvInspector,
  SynEditHighlighter, SynHighlighterDfm, StdActns, SynEdit,
  JvDesignSurface, StdCtrls, Spin, jvDesignUtils,
  jvdesignimp, buttons, ExtCtrls, JvInspExtraEditors, Menus, clipbrd, typinfo;

type
  TDesignForm = class(TForm)
    ImageList1: TImageList;
    CoolBar1: TCoolBar;
    ActionManager1: TActionManager;
    ActionMainMenuBar1: TActionMainMenuBar;
    ActionToolBar1: TActionToolBar;
    Splitter1: TSplitter;
    MainPanel: TPanel;
    ComponentPages: TPageControl;
    StandardTab: TTabSheet;
    DesignPages: TPageControl;
    DesignTab: TTabSheet;
    ToolBar1: TToolBar;
    SelectButton: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ImageList2: TImageList;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    JvDesignScrollBox1: TJvDesignScrollBox;
    DesignPanel: TPanel;
    Designer: TJvDesignPanel;
    FileOpen1: TFileOpen;
    FileSaveAs1: TFileSaveAs;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    EditDelete1: TEditDelete;
    SaveAction: TAction;
    SynDfmSyn1: TSynDfmSyn;
    AdditionalTab: TTabSheet;
    ToolBar2: TToolBar;
    ImageList3: TImageList;
    ToolButton1: TToolButton;
    ToolButton4: TToolButton;
    ToolButton15: TToolButton;
    ToolButton16: TToolButton;
    ToolButton17: TToolButton;
    ToolButton18: TToolButton;
    ToolButton19: TToolButton;
    PageAddAction: TAction;
    PopupMenu1: TPopupMenu;
    PageAddAction1: TMenuItem;
    ToolButton20: TToolButton;
    ToolButton21: TToolButton;
    ToolButton22: TToolButton;
    InspectorPanel: TPanel;
    ComponentPanel: TPanel;
    JvInspector1: TJvInspector;
    ComponentCombo: TComboBox;
    SelParentAction: TAction;
    SelectParent1: TMenuItem;
    PageNextAction: TAction;
    PagePrevAction: TAction;
    PageDelAction: TAction;
    NextPage1: TMenuItem;
    PreviousPage1: TMenuItem;
    DeletePage1: TMenuItem;
    NewAction: TAction;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DesignerSelectionChange(Sender: TObject);
    procedure JvInspector1ItemValueChanged(Sender: TObject;
      Item: TJvCustomInspectorItem);
    procedure DesignerGetAddClass(Sender: TObject;
      var ioClass: String);
    procedure ToolButton2Click(Sender: TObject);
    procedure SelectButtonClick(Sender: TObject);
    procedure ActionManager1Update(Action: TBasicAction;
      var Handled: Boolean);
    procedure EditCut1Execute(Sender: TObject);
    procedure EditCopy1Execute(Sender: TObject);
    procedure EditPaste1Execute(Sender: TObject);
    procedure EditDelete1Execute(Sender: TObject);
    procedure EditUpdate(Sender: TObject);
    procedure SaveActionUpdate(Sender: TObject);
    procedure FileSaveAs1Accept(Sender: TObject);
    procedure SaveActionExecute(Sender: TObject);
    procedure FileOpen1Accept(Sender: TObject);
    procedure PageActionUpdate(Sender: TObject);
    procedure PageAddActionExecute(Sender: TObject);
    procedure JvInspector1ItemValueError(Sender: TObject;
      Item: TJvCustomInspectorItem; ExceptObject: Exception);
    procedure ComponentComboChange(Sender: TObject);
    procedure SelParentActionUpdate(Sender: TObject);
    procedure SelParentActionExecute(Sender: TObject);
    procedure PageNextActionExecute(Sender: TObject);
    procedure PagePrevActionExecute(Sender: TObject);
    procedure PageDelActionExecute(Sender: TObject);
    procedure EditPaste1Update(Sender: TObject);
    procedure JvInspector1AfterItemCreate(Sender: TObject;
      Item: TJvCustomInspectorItem);
    procedure NewActionExecute(Sender: TObject);
  private
    { Private declarations }
  public
    DesignClass: string;
    StickyClass: Boolean;
    formname: string;
    InspectObject: TObject;
    procedure LoadFromFile;
    Procedure UpdateCombo;
    procedure InspectClass(value: TComponent);
    procedure InspectForm;
  end;

var
  DesignForm: TDesignForm;

implementation

{$R *.dfm}

procedure TDesignForm.FormCreate(Sender: TObject);
begin
  if Screen.PixelsPerInch <> PixelsPerInch then
  begin
    ScaleBy(Screen.PixelsPerInch, PixelsPerInch);
  end;
  Designer.Surface.MessengerClass := TJvDesignWinControlHookMessenger;
  Designer.Surface.Active := true;
end;

procedure TDesignForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := cafree;
end;

procedure TDesignForm.DesignerSelectionChange(Sender: TObject);
var
  i: integer;
  s: string;
begin
  UpdateCombo;
  if (Designer.Surface.Count = 1) and (Designer.Surface.Selection[0] is TObject) then
    InspectClass(Designer.Surface.Selection[0])
  else
  begin
    InspectForm;
  end;
//  Designer.Surface.UpdateDesigner;
end;

procedure TDesignForm.JvInspector1ItemValueChanged(Sender: TObject;
  Item: TJvCustomInspectorItem);
begin
  UpdateCombo;
  Designer.Surface.UpdateDesigner;
end;

procedure TDesignForm.DesignerGetAddClass(Sender: TObject;
  var ioClass: String);
begin
  ioClass := DesignClass;
  if not StickyClass then
  begin
    DesignClass := '';
    SelectButton.Down := true;
  end;
end;

procedure TDesignForm.ToolButton2Click(Sender: TObject);
begin
  StickyClass := (GetKeyState(VK_SHIFT) < 0);
  DesignClass := TToolButton(Sender).Caption;
end;

procedure TDesignForm.SelectButtonClick(Sender: TObject);
begin
  StickyClass := false;
  DesignClass := '';
end;

procedure TDesignForm.ActionManager1Update(Action: TBasicAction;
  var Handled: Boolean);
begin
  Handled := not Assigned(Action.OnUpdate);
end;

procedure TDesignForm.EditCut1Execute(Sender: TObject);
begin
  Designer.Surface.CutComponents;
  Designer.Surface.UpdateDesigner;
end;

procedure TDesignForm.EditCopy1Execute(Sender: TObject);
begin
  Designer.Surface.CopyComponents;
  Designer.Surface.UpdateDesigner;
end;

procedure TDesignForm.EditPaste1Execute(Sender: TObject);
begin
  Designer.Surface.PasteComponents;
  Designer.Surface.UpdateDesigner;
end;

procedure TDesignForm.EditDelete1Execute(Sender: TObject);
begin
  Designer.Surface.DeleteComponents;
  Designer.Surface.UpdateDesigner;
end;

procedure TDesignForm.EditUpdate(Sender: TObject);
var
  b: boolean;
begin
  if (Sender is TAction) then
  begin
    b := Designer.Focused;
    if b then
      b := Designer.Surface.Count > 0;
    TAction(sender).Enabled := b;
  end;
end;

procedure TDesignForm.SaveActionUpdate(Sender: TObject);
begin
  SaveAction.Enabled := formname <> '';
end;

procedure TDesignForm.FileSaveAs1Accept(Sender: TObject);
begin
  formname := filesaveas1.Dialog.FileName;
  SaveAction.Execute;
end;

procedure TDesignForm.SaveActionExecute(Sender: TObject);
var
  fs: TFileStream;
begin
  self.Caption := extractfilename(formname);
  fs := TFileStream.Create(formname, fmCreate	or fmShareExclusive);
  try
    Designer.SaveToStream(fs);
  finally
    fs.free;
  end;
end;

procedure TDesignForm.FileOpen1Accept(Sender: TObject);
var
  s: string;
begin
  s := FileOpen1.Dialog.FileName;
  formname := s;
  self.Caption := extractfilename(formname);
  LoadFromFile;
  Designer.Surface.Active := true;
  Designer.Surface.UpdateDesigner;
end;

procedure TDesignForm.LoadFromFile;
var
  l: tstringlist;
  n: integer;
  c: integer;
  ms: TMemoryStream;
  s: string;
  sv: string;
  dpi: integer;
begin
    Designer.LoadFromFile(formname);
    Designer.DrawRules := true;
    Designer.Surface.Active := true;
end;

procedure TDesignForm.PageActionUpdate(Sender: TObject);
begin
  if (Sender is TAction) then
    if self.Active then
    begin
      if InspectObject is TObject then
        TAction(sender).Enabled := InspectObject.ClassName = 'TPageControl'
      else
        TAction(sender).Enabled := false;
      TAction(sender).Visible := TAction(sender).Enabled;
    end;
end;

procedure TDesignForm.PageAddActionExecute(Sender: TObject);
var
  pg: TPageControl;
  ts: TTabSheet;
  co: TWinControl;
begin
  if InspectObject is TPageControl then
  begin
    pg := TPageControl(InspectObject);
    if assigned(designer.Surface.SelectedContainer) then
      co := designer.Surface.SelectedContainer
    else
      co := designer.Surface.Container;
    ts:=TTabSheet.Create(co);
    ts.Name := DesignUniqueName(designer.Surface.Container, 'TTabSheet');
    ts.Caption := ts.name;
    ts.PageControl := pg;
    designer.Surface.Messenger.DesignComponent(ts, Active);
    designer.Surface.UpdateDesigner;
  end;
end;

procedure TDesignForm.JvInspector1ItemValueError(Sender: TObject;
  Item: TJvCustomInspectorItem; ExceptObject: Exception);
begin
  Showmessage(ExceptObject.Message);
end;

procedure TDesignForm.ComponentComboChange(Sender: TObject);
var
  c: TControl;
begin
  c :=TControl(designer.Surface.Container.FindComponent(ComponentCombo.Text));
  Designer.Surface.Select(c);
  InspectClass(c);
  Designer.Surface.UpdateDesigner;
end;

procedure TDesignForm.UpdateCombo;
var
  i: integer;
  s: string;
begin
  ComponentCombo.Items.BeginUpdate;
  try
    ComponentCombo.Clear;
    for i := 0 to Designer.Surface.Container.ComponentCount - 1 do
    begin
      s := Designer.Surface.Container.Components[i].Name;
      if s <> 'Surface' then
        ComponentCombo.items.add(s);
    end;
  finally
    ComponentCombo.Items.EndUpdate;
  end;
  if (Designer.Surface.Count = 1)
    and (Designer.Surface.Selection[0] is TComponent) then
  begin
    ComponentCombo.ItemIndex
      := ComponentCombo.Items.IndexOf(TComponent(Designer.Surface.Selection[0]).Name);
  end
  else
  begin
    ComponentCombo.ItemIndex := -1;
  end;
end;

procedure TDesignForm.SelParentActionUpdate(Sender: TObject);
var
  b: boolean;
begin
  if (Sender is TAction) then
    if self.Active then
    begin
      b := assigned(InspectObject);
      if InspectObject is TControl then
        if b then
          b := TControl(InspectObject).Parent <> Designer.Surface.Container;
      TAction(sender).Enabled := b;
    end;
end;

procedure TDesignForm.SelParentActionExecute(Sender: TObject);
begin
  Designer.Surface.SelectParent;
  Designer.Surface.UpdateDesigner;
end;

procedure TDesignForm.PageNextActionExecute(Sender: TObject);
var
  pg: TPageControl;
begin
  if InspectObject is TPageControl then
  begin
    pg := TPageControl(InspectObject);
    pg.SelectNextPage(true, false);
    jvInspector1.RefreshValues;
    designer.Surface.UpdateDesigner;
  end;
end;

procedure TDesignForm.PagePrevActionExecute(Sender: TObject);
var
  pg: TPageControl;
begin
  if InspectObject is TPageControl then
  begin
    pg := TPageControl(InspectObject);
    pg.SelectNextPage(false, false);
    jvInspector1.RefreshValues;
    designer.Surface.UpdateDesigner;
  end;
end;

procedure TDesignForm.PageDelActionExecute(Sender: TObject);
var
  pg: TPageControl;
  sh: TTabSheet;
begin
  if InspectObject is TPageControl then
  begin
    pg := TPageControl(InspectObject);
    sh := pg.ActivePage;
    if assigned(sh) then
    begin
      sh.PageControl := nil;
      sh.Parent := nil;
      sh.Free;
    end;
    jvInspector1.RefreshValues;
    designer.Surface.UpdateDesigner;
  end;
end;

procedure TDesignForm.EditPaste1Update(Sender: TObject);
begin
  if (Sender is TAction) then
    if self.Active then
    begin
      TAction(sender).Enabled := Clipboard.HasFormat(RegisterClipboardFormat('Delphi Components'));
    end;
end;

procedure TDesignForm.InspectClass(value: TComponent);
begin
  jvinspector1.BeginUpdate;
  try
    jvinspector1.Clear;
    ComponentCombo.ItemIndex := -1;
    if assigned(value) then
    begin
      JvInspector1.AddComponent(value, value.Name + ': ' + value.ClassName, true);
      ComponentCombo.ItemIndex := ComponentCombo.Items.IndexOf(Value.Name);
      InspectObject := value;
    end
    else
      InspectForm;
  finally
    jvinspector1.EndUpdate;
  end;
end;

procedure TDesignForm.JvInspector1AfterItemCreate(Sender: TObject;
  Item: TJvCustomInspectorItem);
begin
  if Item is TJvInspectorBooleanItem then
    TJvInspectorBooleanItem(Item).ShowAsCheckbox := True;
end;

procedure TDesignForm.InspectForm;
begin
    InspectObject := nil;
end;

procedure TDesignForm.NewActionExecute(Sender: TObject);
begin
  formname := '';
  self.Caption := '';
  Designer.Clear;
end;

initialization
  RegisterClass(TLabel);
  RegisterClass(TEdit);
  RegisterClass(TMemo);
  RegisterClass(TButton);
  RegisterClass(TCheckbox);
  RegisterClass(TRadioButton);
  RegisterClass(TListBox);
  RegisterClass(TCombobox);
  RegisterClass(TScrollBar);
  RegisterClass(TGroupBox);
  RegisterClass(TRadioGroup);
  RegisterClass(TPanel);
  RegisterClass(TBitBtn);
  RegisterClass(TSpeedButton);
  RegisterClass(TShape);
  RegisterClass(TBevel);
  RegisterClass(TImage);
  RegisterClass(TPageControl);
  RegisterClass(TTabSheet);
  RegisterClass(TProgressBar);
  RegisterClass(TDateTimePicker);
  RegisterClass(TMonthCalendar);
end.
